## libmongoc 1.1.0-11~1

=== debian/changelog ===
libmongoc (1.1.0-11~1-sid+1) unstable; urgency=low

  * Nightly build.

 -- William King <william.king@quentustech.com>  Mon, 01 Jun 2015 16:50:41 -0400

libmongoc (1.1.0-1) unstable; urgency=low

  * Initial release (Closes: #nnnn)  <nnnn is the bug number of your ITP>

 -- William King <william.king@quentustech.com>  Wed, 01 Apr 2015 11:37:34 -0700
