=== debian/control ===
Source: libmongoc
Priority: extra
Maintainer: William King <william.king@quentustech.com>
Build-Depends: debhelper (>= 8.0.0), autotools-dev
Standards-Version: 3.9.3
Section: libs
Homepage: <insert the upstream URL, if relevant>
#Vcs-Git: git://git.debian.org/collab-maint/libmongoc.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/libmongoc.git;a=summary

Package: libmongoc-dev
Section: libdevel
Architecture: any
Depends: libmongoc1 (= ${binary:Version})
Description: <insert up to 60 chars description>
 <insert long description, indented with spaces>

Package: libmongoc1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: <insert up to 60 chars description>
 <insert long description, indented with spaces>
