=== debian/changelog ===
libmongoc (1.3.1-1) experimental; urgency=low

  * New upstream release.
  * Remove libmongoc-priv and libmongoc-priv-dev packages.

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Tue, 19 Jan 2016 20:14:19 +0000

libmongoc (1.2.1-1) experimental; urgency=low

  * Initial release (Closes: #798711)

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Fri, 06 Nov 2015 20:21:17 +0000
