=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS

export DPKG_GENSYMBOLS_CHECK_LEVEL=4

# main packaging script based on dh7 syntax
%:
	dh $@ --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -- \
	--prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info --enable-debug-symbols=yes --enable-html-docs=yes --enable-man-pages=yes --enable-maintainer-flags=yes --with-libbson=system --enable-tests=no
	# Upstream's autogen.sh creates this symlink, but dh-autoreconf doesn't
	[ -f README ] || /bin/cp README.rst README

override_dh_auto_build:
	dh_auto_build
	make html

override_dh_auto_clean:
	dh_auto_clean
	[ ! -f README ] || /bin/rm -f README

override_dh_strip:
	dh_strip -a --dbg-package=libmongoc-dbg

override_dh_install:
	dh_install -a -X.la -Xmongoc-stat -Xdoc/mongo-c-driver -Xman/man3 -X-priv.so -X-priv.pc -X-private.h --fail-missing
