## libmongoc 1.3.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,6 +10,7 @@
 option(ENABLE_SASL "Use Cyrus SASL library for Kerberos." ON)
 option(ENABLE_TESTS "Build MongoDB C Driver tests." ON)
 option(ENABLE_EXAMPLES "Build MongoDB C Driver examples." ON)
+option(ENABLE_AUTOMATIC_INIT_AND_CLEANUP "Enable automatic init and cleanup (GCC only)" ON)
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/build/cmake)
 
@@ -33,6 +34,12 @@
 else ()
    set (MONGOC_HAVE_SASL_CLIENT_DONE 0)
    set (MONGOC_ENABLE_SASL 0)
+endif ()
+
+if (ENABLE_AUTOMATIC_INIT_AND_CLEANUP)
+   set (MONGOC_NO_AUTOMATIC_GLOBALS 0)
+else ()
+   set (MONGOC_NO_AUTOMATIC_GLOBALS 1)
 endif ()
 
 set (SOURCE_DIR "${PROJECT_SOURCE_DIR}/")
@@ -312,8 +319,3 @@
    ${SOURCE_DIR}/tests/test-mongoc-stream.c
    ${SOURCE_DIR}/tests/test-mongoc-thread.c
    ${SOURCE_DIR}/tests/test-mongoc-topology.c
-   ${SOURCE_DIR}/tests/test-mongoc-topology-reconcile.c
-   ${SOURCE_DIR}/tests/test-mongoc-topology-scanner.c
-   ${SOURCE_DIR}/tests/test-mongoc-uri.c
-   ${SOURCE_DIR}/tests/test-mongoc-version.c
-   ${SOURCE_DIR}/tests/test-mongoc-usleep.c
