=== debian/changelog ===
libmongoc (1.3.5-1) unstable; urgency=low

  [ A. Jesse Jiryu Davis]
  * Upstream release
  * Updated to Standards-Version 3.9.8 (no changes)

  [ Roberto C. Sanchez ]
  * Adjust which files get installed into the binary packages:
  * Add new symbols that appeared in 1.3.1
  * Add patch authorship/description info
  * Make sure man pages are picked up from the proper directory

  [ Ondřej Surý ]
  * Add stricter dependency on libbson
  * Remove -dbg package and add a simple BC compatible dbgsym support

 -- A. Jesse Jiryu Davis <jesse@mongodb.com>  Tue, 17 May 2016 12:12:28 -0400
