=== debian/control ===
Source: libmongoc
Priority: optional
Maintainer: A. Jesse Jiryu Davis <jesse@mongodb.com>
Build-Depends: debhelper (>= 9),
               dh-autoreconf,
               libbson-dev (>= 1.3.5),
               libssl-dev,
               pkg-config,
               yelp-tools,
               yelp-xsl
Standards-Version: 3.9.8
Section: libs
Homepage: https://github.com/mongodb/mongo-c-driver
Vcs-Git: https://github.com/mongodb/mongo-c-driver.git
Vcs-Browser: https://github.com/mongodb/mongo-c-driver/tree/debian

Package: libmongoc-dev
Section: libdevel
Architecture: any
Depends: libmongoc-1.0-0 (= ${binary:Version}),
         ${misc:Depends}
Description: MongoDB C client library - dev files
 libmongoc is the officially supported MongoDB client library for C
 applications.
 .
 This package contains all files necessary to develop applications which
 use libmongoc.

Package: libmongoc-1.0-0
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: MongoDB C client library - runtime files
 libmongoc is the officially supported MongoDB client library for C
 applications.
 .
 This package contains the libmongoc runtime libraries, for applications that
 have been built with libmongoc.

Package: libmongoc-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: MongoDB C client library - documentation
 libmongoc is the officially supported MongoDB client library for C
 applications.
 .
 This package contains the man pages for libmongoc.
