=== debian/rules ===
--- 
+++ 
@@ -29,14 +29,14 @@
 
 override_dh_auto_build:
 	dh_auto_build
-	make html
+	make man html
 
 override_dh_auto_clean:
 	dh_auto_clean
 	[ ! -f README ] || /bin/rm -f README
 
 override_dh_strip:
-	dh_strip -a --dbg-package=libmongoc-dbg
+	dh_strip --dbgsym-migration='libmongoc-dbg (<< 1.3.1-2~)' || dh_strip
 
 override_dh_install:
 	dh_install -a -X.la -Xmongoc-stat -Xdoc/mongo-c-driver -Xman/man3 -X-priv.so -X-priv.pc -X-private.h --fail-missing
